<?php

// QuickTalk 1.9.0.3 build:20081001
// Script added in qtf_form_edit.php when rss is activated.

function MakeRss($s=-1)
{

// check
if ( $_SESSION[QT]['m_rss']!='1' ) return false;
if ( $s<0 ) die('MakeFeeds: Wrong forum');

global $oDB,$L;

// read forum info
$oSEC = new cSection($s);

if ( $oSEC->type!='0' ) return false;

$arr = explode(' ',$_SESSION[QT]['m_rss_conf']);
$top = $arr[2];

// search new topics
$strState  = 't.*,p.title,p.textmsg FROM '.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid=p.id WHERE t.forum='.$s;
$strOrder  = 't.lastpostdate DESC';
$oDB->Query( LimitSQL($strState,$strOrder,0,$top) );
$i=0;
while ($row = $oDB->Getrow())
{
  $item[$i]['title'] = $row['title'];
  $item[$i]['link'] = $_SESSION[QT]['site_url'].'/qtf_topic.php?s='.$s.'&amp;t='.$row['id'].'&amp;p='.$row['firstpostid'];

  // format the RSS text
  $item[$i]['description'] = QTbbc(QTcompactline($row['textmsg'],450),'drop',' ',400);
  $item[$i]['pubDate'] = $row['lastpostdate'];
  $item[$i]['author'] = $row['firstpostname'];
  $i++;
}

// write rss 0.91
$strFilename = 'rss/qtf_091_'.$s.'.xml';
if ( file_exists($strFilename) )
{
  if ( !is_writable($strFilename) )
  {
  echo $strFilename,' not writable<br/>';
  return false;
  }
}

$handle = fopen('rss/qtf_091_'.$s.'.xml','w');
fwrite($handle,'<?xml version="1.0" encoding="'.QTF_HTML_CHAR.'" ?><rss version="0.91"><channel>'.N);
fwrite($handle,'<title>'.$_SESSION[QT]['site_name'].' - '.$oSEC->name.'</title>');
fwrite($handle,'<link>'.$_SESSION[QT]['site_url'].'/qtf_topics.php?s='.$s.'</link>');
fwrite($handle,"<description>$oSEC->descr</description>\n");
fwrite($handle,"<language>".QTF_HTML_LANG."</language>\n");
fwrite($handle,"<image><url>{$_SESSION[QT]['site_url']}/rss/qtf_logo.gif</url><title>{$_SESSION[QT]['site_name']} - $oSEC->name</title><link>{$_SESSION[QT]['site_url']}/qtf_topics.php?s=$s</link><width>110</width><height>50</height></image>\n");
for ($n=0; $n<$i; $n++)
{
fwrite($handle,"<item>\n");
fwrite($handle,"<title>{$item[$n]["title"]}</title>\n");
fwrite($handle,"<link>{$item[$n]["link"]}</link>\n");
fwrite($handle,"<description>[".QTdate($item[$n]['pubDate'],array('n','date','m/d','',$L['dateSQL']))."] {$item[$n]["description"]}</description>\n");
fwrite($handle,"</item>\n");
}
fwrite($handle,'</channel></rss>');
fclose($handle);

// write rss 2.0
if ( file_exists($strFilename) )
{
  if ( !is_writable($strFilename) )
  {
  echo $strFilename,' not writable<br/>';
  return false;
  }
}
$handle = fopen('rss/qtf_2_'.$s.'.xml','w');
fwrite($handle,'<?xml version="1.0" encoding="'.QTF_HTML_CHAR.'" ?><rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom"><channel>'.N);
fwrite($handle,'<title>'.$_SESSION[QT]['site_name'].' - '.$oSEC->name.'</title>');
fwrite($handle,'<link>'.$_SESSION[QT]['site_url'].'/qtf_topics.php?s='.$s.'</link>');
fwrite($handle,'<description>'.$oSEC->descr.'</description>');
fwrite($handle,"<language>".QTF_HTML_LANG."</language>\n");
fwrite($handle,"<generator>QuickTalk ".QTFVERSION."</generator>\n");
fwrite($handle,"<managingEditor>{$_SESSION[QT]['admin_email']} (webmaster)</managingEditor>\n");
fwrite($handle,"<category>QuickTalk</category>\n");
fwrite($handle,"<image><url>{$_SESSION[QT]['site_url']}/rss/qtf_logo.gif</url><title>{$_SESSION[QT]['site_name']}</title><link>{$_SESSION[QT]['site_url']}/qtf_topics.php?s=$s</link><width>110</width><height>50</height></image>\n");
for ($n=0; $n<$i; $n++)
{
fwrite($handle,"<item>\n");
fwrite($handle,"<title>{$item[$n]['title']}</title>\n");
fwrite($handle,"<link>{$item[$n]['link']}</link>\n");
fwrite($handle,"<description>{$item[$n]['description']}</description>\n");
fwrite($handle,"<pubDate>".QTdate($item[$n]['pubDate'],array('n','date','D, d M Y H:i:00 O','',$L['dateSQL']))."</pubDate>\n");
fwrite($handle,"<guid>{$item[$n]['link']}</guid>\n");
fwrite($handle,"</item>\n");
}
fwrite($handle,'<atom:link href="'.$_SESSION[QT]['site_url'].'/rss/qtf_2_'.$s.'.xml" rel="self" type="application/rss+xml" /></channel></rss>');
fclose($handle);

// write atom 1.0
$strFilename = 'rss/qtf_atom_'.$s.'.xml';
if ( file_exists($strFilename) )
{
  if ( !is_writable($strFilename) )
  {
  echo $strFilename,' not writable<br/>';
  return false;
  }
}
$handle = fopen('rss/qtf_atom_'.$s.'.xml','w');
fwrite($handle,'<?xml version="1.0" encoding="'.QTF_HTML_CHAR.'" ?><feed xmlns="http://www.w3.org/2005/Atom">');
fwrite($handle,'<title>'.$_SESSION[QT]['site_name'].' - '.$oSEC->name.'</title>');
fwrite($handle,'<link href="'.$_SESSION[QT]['site_url'].'/qtf_topics.php?s='.$s.'"/>');
fwrite($handle,'<link href="'.$_SESSION[QT]['site_url'].'/rss/qtf_atom_'.$s.'.xml" rel="self"/>');
fwrite($handle,"<id>{$_SESSION[QT]['site_url']}/qtf_topics.php?s=$s</id>\n");
fwrite($handle,"<updated>".QTdate(date('Y-m-d H:i:s'),array('s','RFC-3339'))."</updated>\n");
fwrite($handle,"<author><name>Webmaster</name><email>{$_SESSION[QT]['admin_email']}</email></author>\n");
fwrite($handle,"<category term=\"QuickTalk\"/>\n");
fwrite($handle,"<generator>QuickTalk ".QTFVERSION."</generator>\n");
fwrite($handle,"<icon>{$_SESSION[QT]['site_url']}/rss/qtf_icon.gif</icon>\n");
fwrite($handle,"<logo>{$_SESSION[QT]['site_url']}/rss/qtf_logo.gif</logo>\n");
for ($n=0; $n<$i; $n++)
{
fwrite($handle,"<entry>\n");
fwrite($handle,"<id>{$item[$n]['link']}</id>\n");
fwrite($handle,"<title>{$item[$n]['title']}</title>\n");
fwrite($handle,"<updated>".QTdate($item[$n]['pubDate'],array('n','RFC-3339'))."</updated>\n");
fwrite($handle,"<author><name>{$item[$n]['author']}</name></author>\n");
fwrite($handle,"<content>{$item[$n]['description']}</content>\n");
fwrite($handle,"<link href=\"{$item[$n]['link']}\"/>\n");
fwrite($handle,"</entry>\n");
}
fwrite($handle,'</feed>');
fclose($handle);

}

/**
 *
 * Execute the command (from qtf_form_edit.php)
 *
 **/

MakeRss($s);

?>